﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTabs;
using Infragistics.Win.UltraWinTabControl;

namespace AddingNewTabs
{
    class NewTabCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            Infragistics.Win.Appearance app = new Infragistics.Win.Appearance();
            app.BackColor = Color.PeachPuff;
            if (parent is TabItemUIElement)
            {
                ButtonUIElement button = new ButtonUIElement(parent);
                button.Text = "New Tab";
                button.ElementClick += new UIElementEventHandler(button_ElementClick);

                var tab = parent.GetContext(typeof(UltraTab)) as UltraTab;
                if (tab.Index == tab.TabControl.Tabs.Count - 1)
                {
                    int x = parent.Rect.X;
                    x += 50;
                    Rectangle rect = new Rectangle(new Point(x, 0), new Size(65, 24));
                    button.Rect = rect;
                    button.Appearance = app;

                    var headerArea = parent.GetAncestor(typeof(TabHeaderAreaUIElement));
                    headerArea.ChildElements.Add(button);
                }
            }
        }

        void button_ElementClick(object sender, UIElementEventArgs e)
        {
            var tabControlUIElement = e.Element.GetAncestor(typeof(UltraTabControlUIElement));
            var tabControl = tabControlUIElement.GetContext(typeof(UltraTabControl)) as UltraTabControl;
            tabControl.Tabs.Add();
            tabControl.Tabs[tabControl.Tabs.Count - 1].Text = "Tab " + tabControl.Tabs.Count.ToString();
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
